---
title: 'TypeError: can''t redefine non-configurable property "x"'
slug: Web/JavaScript/Reference/Errors/Cant_redefine_property
tags:
  - Error
  - Errors
  - JavaScript
  - TypeError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "can't redefine non-configurable property" occurs when it was attempted to redefine a property, but that property is <a href="/en-US/docs/Web/JavaScript/Data_structures#Properties">non-configurable</a>.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">TypeError: Cannot modify non-writable property {x} (Edge)
TypeError: can't redefine non-configurable property "x" (Firefox)
TypeError: Cannot redefine property: "x" (Chrome)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("TypeError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>It was attempted to redefine a property, but that property is <a href="/en-US/docs/Web/JavaScript/Data_structures#Properties">non-configurable</a>. The <code>configurable</code> attribute controls whether the property can be deleted from the object and whether its attributes (other than <code>writable</code>) can be changed. Usually, properties in an object created by an <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Object_initializer">object initializer</a> are configurable. However, for example, when using {{jsxref("Object.defineProperty()")}}, the property isn't configurable by default.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Non-configurable_properties_created_by_Object.defineProperty">Non-configurable properties created by <code>Object.defineProperty</code></h3>

<p>The {{jsxref("Object.defineProperty()")}} creates non-configurable properties if you haven't specified them as configurable.</p>

<pre class="brush: js example-bad">var obj = Object.create({});
Object.defineProperty(obj, "foo", {value: "bar"});

Object.defineProperty(obj, "foo", {value: "baz"});
// TypeError: can't redefine non-configurable property "foo"
</pre>

<p>You will need to set the "foo" property to configurable, if you intend to redefine it later in the code.</p>

<pre class="brush: js example-good">var obj = Object.create({});
Object.defineProperty(obj, "foo", {value: "bar", configurable: true});
Object.defineProperty(obj, "foo", {value: "baz", configurable: true});</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Data_structures#Properties">[[Configurable]]</a></li>
 <li>{{jsxref("Object.defineProperty()")}}</li>
</ul>
